=begin
#Hydrogen Nucleus API

#The Hydrogen Nucleus API

OpenAPI spec version: 1.9.4
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.20

=end

require 'uri'

module NucleusApi
  class HouseholdApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a Household
    # Create a new household, with your firm.
    # @param household household
    # @param [Hash] opts the optional parameters
    # @return [Household]
    def create_household_using_post(household, opts = {})
      data, _status_code, _headers = create_household_using_post_with_http_info(household, opts)
      data
    end

    # Create a Household
    # Create a new household, with your firm.
    # @param household household
    # @param [Hash] opts the optional parameters
    # @return [Array<(Household, Fixnum, Hash)>] Household data, response status code and response headers
    def create_household_using_post_with_http_info(household, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HouseholdApi.create_household_using_post ...'
      end
      # verify the required parameter 'household' is set
      if @api_client.config.client_side_validation && household.nil?
        fail ArgumentError, "Missing the required parameter 'household' when calling HouseholdApi.create_household_using_post"
      end
      # resource path
      local_var_path = '/nucleus/v1/household'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(household)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Household')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HouseholdApi#create_household_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a Household
    # Permanently delete a household
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_household_using_delete(household_id, opts = {})
      delete_household_using_delete_with_http_info(household_id, opts)
      nil
    end

    # Delete a Household
    # Permanently delete a household
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_household_using_delete_with_http_info(household_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HouseholdApi.delete_household_using_delete ...'
      end
      # verify the required parameter 'household_id' is set
      if @api_client.config.client_side_validation && household_id.nil?
        fail ArgumentError, "Missing the required parameter 'household_id' when calling HouseholdApi.delete_household_using_delete"
      end
      # resource path
      local_var_path = '/nucleus/v1/household/{household_id}'.sub('{' + 'household_id' + '}', household_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HouseholdApi#delete_household_using_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all household
    # Get details for all Household.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending (default to false)
    # @option opts [String] :filter filter
    # @option opts [String] :order_by order_by (default to update_date)
    # @option opts [Integer] :page page (default to 0)
    # @option opts [Integer] :size size (default to 25)
    # @return [PageHousehold]
    def get_household_all_using_get(opts = {})
      data, _status_code, _headers = get_household_all_using_get_with_http_info(opts)
      data
    end

    # List all household
    # Get details for all Household.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending
    # @option opts [String] :filter filter
    # @option opts [String] :order_by order_by
    # @option opts [Integer] :page page
    # @option opts [Integer] :size size
    # @return [Array<(PageHousehold, Fixnum, Hash)>] PageHousehold data, response status code and response headers
    def get_household_all_using_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HouseholdApi.get_household_all_using_get ...'
      end
      # resource path
      local_var_path = '/nucleus/v1/household'

      # query parameters
      query_params = {}
      query_params[:'ascending'] = opts[:'ascending'] if !opts[:'ascending'].nil?
      query_params[:'filter'] = opts[:'filter'] if !opts[:'filter'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PageHousehold')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HouseholdApi#get_household_all_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all household client asset sizes
    # Get a list of asset sizes per date for a client's household.
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :currency_conversion USD
    # @option opts [Date] :end_date end date (default to null)
    # @option opts [BOOLEAN] :exclude_subledger true or false
    # @option opts [BOOLEAN] :get_latest true or false
    # @option opts [String] :sort_type  Quarter (Q), Monthly (M) , Annually (Y), Daily (D) --caps matter, codes in ()
    # @option opts [Date] :start_date start date (default to null)
    # @return [Array<AvailableDateDoubleVO>]
    def get_household_client_asset_size_using_get(household_id, opts = {})
      data, _status_code, _headers = get_household_client_asset_size_using_get_with_http_info(household_id, opts)
      data
    end

    # List all household client asset sizes
    # Get a list of asset sizes per date for a client&#39;s household.
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :currency_conversion USD
    # @option opts [Date] :end_date end date
    # @option opts [BOOLEAN] :exclude_subledger true or false
    # @option opts [BOOLEAN] :get_latest true or false
    # @option opts [String] :sort_type  Quarter (Q), Monthly (M) , Annually (Y), Daily (D) --caps matter, codes in ()
    # @option opts [Date] :start_date start date
    # @return [Array<(Array<AvailableDateDoubleVO>, Fixnum, Hash)>] Array<AvailableDateDoubleVO> data, response status code and response headers
    def get_household_client_asset_size_using_get_with_http_info(household_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HouseholdApi.get_household_client_asset_size_using_get ...'
      end
      # verify the required parameter 'household_id' is set
      if @api_client.config.client_side_validation && household_id.nil?
        fail ArgumentError, "Missing the required parameter 'household_id' when calling HouseholdApi.get_household_client_asset_size_using_get"
      end
      # resource path
      local_var_path = '/nucleus/v1/household/{household_id}/asset_size'.sub('{' + 'household_id' + '}', household_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'currency_conversion'] = opts[:'currency_conversion'] if !opts[:'currency_conversion'].nil?
      query_params[:'end_date'] = opts[:'end_date'] if !opts[:'end_date'].nil?
      query_params[:'exclude_subledger'] = opts[:'exclude_subledger'] if !opts[:'exclude_subledger'].nil?
      query_params[:'get_latest'] = opts[:'get_latest'] if !opts[:'get_latest'].nil?
      query_params[:'sort_type'] = opts[:'sort_type'] if !opts[:'sort_type'].nil?
      query_params[:'start_date'] = opts[:'start_date'] if !opts[:'start_date'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<AvailableDateDoubleVO>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HouseholdApi#get_household_client_asset_size_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all household's clientIds holdings
    # Get the information for all the securities that are currently being held by a household's client ids registered with your firm.
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending (default to false)
    # @option opts [String] :currency_conversion USD
    # @option opts [Date] :end_date end date - yyyy-mm-dd
    # @option opts [String] :filter filter
    # @option opts [BOOLEAN] :get_latest true or false
    # @option opts [String] :order_by order_by (default to date)
    # @option opts [Integer] :page page (default to 0)
    # @option opts [Integer] :size size (default to 25)
    # @option opts [Date] :start_date start date - yyyy-mm-dd
    # @return [PagePortfolioHoldingAgg]
    def get_household_client_holding_using_get(household_id, opts = {})
      data, _status_code, _headers = get_household_client_holding_using_get_with_http_info(household_id, opts)
      data
    end

    # List all household&#39;s clientIds holdings
    # Get the information for all the securities that are currently being held by a household&#39;s client ids registered with your firm.
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending
    # @option opts [String] :currency_conversion USD
    # @option opts [Date] :end_date end date - yyyy-mm-dd
    # @option opts [String] :filter filter
    # @option opts [BOOLEAN] :get_latest true or false
    # @option opts [String] :order_by order_by
    # @option opts [Integer] :page page
    # @option opts [Integer] :size size
    # @option opts [Date] :start_date start date - yyyy-mm-dd
    # @return [Array<(PagePortfolioHoldingAgg, Fixnum, Hash)>] PagePortfolioHoldingAgg data, response status code and response headers
    def get_household_client_holding_using_get_with_http_info(household_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HouseholdApi.get_household_client_holding_using_get ...'
      end
      # verify the required parameter 'household_id' is set
      if @api_client.config.client_side_validation && household_id.nil?
        fail ArgumentError, "Missing the required parameter 'household_id' when calling HouseholdApi.get_household_client_holding_using_get"
      end
      # resource path
      local_var_path = '/nucleus/v1/household/{household_id}/holding'.sub('{' + 'household_id' + '}', household_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'ascending'] = opts[:'ascending'] if !opts[:'ascending'].nil?
      query_params[:'currency_conversion'] = opts[:'currency_conversion'] if !opts[:'currency_conversion'].nil?
      query_params[:'end_date'] = opts[:'end_date'] if !opts[:'end_date'].nil?
      query_params[:'filter'] = opts[:'filter'] if !opts[:'filter'].nil?
      query_params[:'get_latest'] = opts[:'get_latest'] if !opts[:'get_latest'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
      query_params[:'start_date'] = opts[:'start_date'] if !opts[:'start_date'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PagePortfolioHoldingAgg')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HouseholdApi#get_household_client_holding_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all household's client ids transactions
    # Get the information for all transactions under a household client ids registered with your firm.
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending (default to false)
    # @option opts [String] :currency_conversion USD
    # @option opts [Date] :end_date end date
    # @option opts [String] :filter filter
    # @option opts [String] :order_by order_by (default to update_date)
    # @option opts [Integer] :page page (default to 0)
    # @option opts [Integer] :size size (default to 25)
    # @option opts [Date] :start_date start date
    # @return [PagePortfolioTransaction]
    def get_household_client_transaction_using_get(household_id, opts = {})
      data, _status_code, _headers = get_household_client_transaction_using_get_with_http_info(household_id, opts)
      data
    end

    # List all household&#39;s client ids transactions
    # Get the information for all transactions under a household client ids registered with your firm.
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending
    # @option opts [String] :currency_conversion USD
    # @option opts [Date] :end_date end date
    # @option opts [String] :filter filter
    # @option opts [String] :order_by order_by
    # @option opts [Integer] :page page
    # @option opts [Integer] :size size
    # @option opts [Date] :start_date start date
    # @return [Array<(PagePortfolioTransaction, Fixnum, Hash)>] PagePortfolioTransaction data, response status code and response headers
    def get_household_client_transaction_using_get_with_http_info(household_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HouseholdApi.get_household_client_transaction_using_get ...'
      end
      # verify the required parameter 'household_id' is set
      if @api_client.config.client_side_validation && household_id.nil?
        fail ArgumentError, "Missing the required parameter 'household_id' when calling HouseholdApi.get_household_client_transaction_using_get"
      end
      # resource path
      local_var_path = '/nucleus/v1/household/{household_id}/transaction'.sub('{' + 'household_id' + '}', household_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'ascending'] = opts[:'ascending'] if !opts[:'ascending'].nil?
      query_params[:'currency_conversion'] = opts[:'currency_conversion'] if !opts[:'currency_conversion'].nil?
      query_params[:'end_date'] = opts[:'end_date'] if !opts[:'end_date'].nil?
      query_params[:'filter'] = opts[:'filter'] if !opts[:'filter'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
      query_params[:'start_date'] = opts[:'start_date'] if !opts[:'start_date'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PagePortfolioTransaction')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HouseholdApi#get_household_client_transaction_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve a Household
    # Retrieve the information for a Household.
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @return [Household]
    def get_household_using_get(household_id, opts = {})
      data, _status_code, _headers = get_household_using_get_with_http_info(household_id, opts)
      data
    end

    # Retrieve a Household
    # Retrieve the information for a Household.
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(Household, Fixnum, Hash)>] Household data, response status code and response headers
    def get_household_using_get_with_http_info(household_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HouseholdApi.get_household_using_get ...'
      end
      # verify the required parameter 'household_id' is set
      if @api_client.config.client_side_validation && household_id.nil?
        fail ArgumentError, "Missing the required parameter 'household_id' when calling HouseholdApi.get_household_using_get"
      end
      # resource path
      local_var_path = '/nucleus/v1/household/{household_id}'.sub('{' + 'household_id' + '}', household_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Household')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HouseholdApi#get_household_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update a Household
    # Update the information for a Household.
    # @param household household
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @return [Household]
    def update_household_using_put(household, household_id, opts = {})
      data, _status_code, _headers = update_household_using_put_with_http_info(household, household_id, opts)
      data
    end

    # Update a Household
    # Update the information for a Household.
    # @param household household
    # @param household_id UUID household_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(Household, Fixnum, Hash)>] Household data, response status code and response headers
    def update_household_using_put_with_http_info(household, household_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HouseholdApi.update_household_using_put ...'
      end
      # verify the required parameter 'household' is set
      if @api_client.config.client_side_validation && household.nil?
        fail ArgumentError, "Missing the required parameter 'household' when calling HouseholdApi.update_household_using_put"
      end
      # verify the required parameter 'household_id' is set
      if @api_client.config.client_side_validation && household_id.nil?
        fail ArgumentError, "Missing the required parameter 'household_id' when calling HouseholdApi.update_household_using_put"
      end
      # resource path
      local_var_path = '/nucleus/v1/household/{household_id}'.sub('{' + 'household_id' + '}', household_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(household)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Household')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HouseholdApi#update_household_using_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
