=begin
#Hydrogen Nucleus API

#The Hydrogen Nucleus API

OpenAPI spec version: 1.9.4
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module NucleusApi
  class OverflowApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a Overflow Settings request
    # Create a new Overflow Settings request.
    # @param overflow_settings overflowSettings
    # @param [Hash] opts the optional parameters
    # @return [OverflowSettings]
    def create_overflow_settings_using_post(overflow_settings, opts = {})
      data, _status_code, _headers = create_overflow_settings_using_post_with_http_info(overflow_settings, opts)
      data
    end

    # Create a Overflow Settings request
    # Create a new Overflow Settings request.
    # @param overflow_settings overflowSettings
    # @param [Hash] opts the optional parameters
    # @return [Array<(OverflowSettings, Fixnum, Hash)>] OverflowSettings data, response status code and response headers
    def create_overflow_settings_using_post_with_http_info(overflow_settings, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OverflowApi.create_overflow_settings_using_post ...'
      end
      # verify the required parameter 'overflow_settings' is set
      if @api_client.config.client_side_validation && overflow_settings.nil?
        fail ArgumentError, "Missing the required parameter 'overflow_settings' when calling OverflowApi.create_overflow_settings_using_post"
      end
      # resource path
      local_var_path = '/nucleus/v1/overflow_setting'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(overflow_settings)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'OverflowSettings')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OverflowApi#create_overflow_settings_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a Overflow request
    # Create a new Overflow request.
    # @param overflow_vo overflowVO
    # @param [Hash] opts the optional parameters
    # @return [Overflow]
    def create_overflow_using_post(overflow_vo, opts = {})
      data, _status_code, _headers = create_overflow_using_post_with_http_info(overflow_vo, opts)
      data
    end

    # Create a Overflow request
    # Create a new Overflow request.
    # @param overflow_vo overflowVO
    # @param [Hash] opts the optional parameters
    # @return [Array<(Overflow, Fixnum, Hash)>] Overflow data, response status code and response headers
    def create_overflow_using_post_with_http_info(overflow_vo, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OverflowApi.create_overflow_using_post ...'
      end
      # verify the required parameter 'overflow_vo' is set
      if @api_client.config.client_side_validation && overflow_vo.nil?
        fail ArgumentError, "Missing the required parameter 'overflow_vo' when calling OverflowApi.create_overflow_using_post"
      end
      # resource path
      local_var_path = '/nucleus/v1/overflow'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(overflow_vo)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Overflow')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OverflowApi#create_overflow_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a overflow settings
    # Permanently delete a  overflow settings registered with your firm.
    # @param overflow_settings_id UUID overflow_settings_id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_overflow_settings_using_delete(overflow_settings_id, opts = {})
      delete_overflow_settings_using_delete_with_http_info(overflow_settings_id, opts)
      nil
    end

    # Delete a overflow settings
    # Permanently delete a  overflow settings registered with your firm.
    # @param overflow_settings_id UUID overflow_settings_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_overflow_settings_using_delete_with_http_info(overflow_settings_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OverflowApi.delete_overflow_settings_using_delete ...'
      end
      # verify the required parameter 'overflow_settings_id' is set
      if @api_client.config.client_side_validation && overflow_settings_id.nil?
        fail ArgumentError, "Missing the required parameter 'overflow_settings_id' when calling OverflowApi.delete_overflow_settings_using_delete"
      end
      # resource path
      local_var_path = '/nucleus/v1/overflow_setting/{overflow_settings_id}'.sub('{' + 'overflow_settings_id' + '}', overflow_settings_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OverflowApi#delete_overflow_settings_using_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all overflow objects
    # Get details for all overflow.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending (default to false)
    # @option opts [String] :filter filter
    # @option opts [String] :order_by order_by (default to update_date)
    # @option opts [Integer] :page page (default to 0)
    # @option opts [Integer] :size size (default to 25)
    # @return [PageOverflow]
    def get_overflow_all_using_get(opts = {})
      data, _status_code, _headers = get_overflow_all_using_get_with_http_info(opts)
      data
    end

    # List all overflow objects
    # Get details for all overflow.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending
    # @option opts [String] :filter filter
    # @option opts [String] :order_by order_by
    # @option opts [Integer] :page page
    # @option opts [Integer] :size size
    # @return [Array<(PageOverflow, Fixnum, Hash)>] PageOverflow data, response status code and response headers
    def get_overflow_all_using_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OverflowApi.get_overflow_all_using_get ...'
      end
      # resource path
      local_var_path = '/nucleus/v1/overflow'

      # query parameters
      query_params = {}
      query_params[:'ascending'] = opts[:'ascending'] if !opts[:'ascending'].nil?
      query_params[:'filter'] = opts[:'filter'] if !opts[:'filter'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PageOverflow')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OverflowApi#get_overflow_all_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all overflow settings
    # Get details for all overflow setting.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending (default to false)
    # @option opts [String] :filter filter
    # @option opts [String] :order_by order_by (default to update_date)
    # @option opts [Integer] :page page (default to 0)
    # @option opts [Integer] :size size (default to 25)
    # @return [PageOverflowSettings]
    def get_overflow_settings_all_using_get(opts = {})
      data, _status_code, _headers = get_overflow_settings_all_using_get_with_http_info(opts)
      data
    end

    # List all overflow settings
    # Get details for all overflow setting.
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending
    # @option opts [String] :filter filter
    # @option opts [String] :order_by order_by
    # @option opts [Integer] :page page
    # @option opts [Integer] :size size
    # @return [Array<(PageOverflowSettings, Fixnum, Hash)>] PageOverflowSettings data, response status code and response headers
    def get_overflow_settings_all_using_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OverflowApi.get_overflow_settings_all_using_get ...'
      end
      # resource path
      local_var_path = '/nucleus/v1/overflow_setting'

      # query parameters
      query_params = {}
      query_params[:'ascending'] = opts[:'ascending'] if !opts[:'ascending'].nil?
      query_params[:'filter'] = opts[:'filter'] if !opts[:'filter'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PageOverflowSettings')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OverflowApi#get_overflow_settings_all_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve a Overflow Setting
    # Retrieve the information for a Overflow Settings.
    # @param overflow_settings_id UUID overflow_settings_id
    # @param [Hash] opts the optional parameters
    # @return [OverflowSettings]
    def get_overflow_settings_using_get(overflow_settings_id, opts = {})
      data, _status_code, _headers = get_overflow_settings_using_get_with_http_info(overflow_settings_id, opts)
      data
    end

    # Retrieve a Overflow Setting
    # Retrieve the information for a Overflow Settings.
    # @param overflow_settings_id UUID overflow_settings_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(OverflowSettings, Fixnum, Hash)>] OverflowSettings data, response status code and response headers
    def get_overflow_settings_using_get_with_http_info(overflow_settings_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OverflowApi.get_overflow_settings_using_get ...'
      end
      # verify the required parameter 'overflow_settings_id' is set
      if @api_client.config.client_side_validation && overflow_settings_id.nil?
        fail ArgumentError, "Missing the required parameter 'overflow_settings_id' when calling OverflowApi.get_overflow_settings_using_get"
      end
      # resource path
      local_var_path = '/nucleus/v1/overflow_setting/{overflow_settings_id}'.sub('{' + 'overflow_settings_id' + '}', overflow_settings_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'OverflowSettings')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OverflowApi#get_overflow_settings_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve a Overflow object
    # Retrieve the information for a Overflow.
    # @param overflow_id UUID overflow_id
    # @param [Hash] opts the optional parameters
    # @return [Overflow]
    def get_overflow_using_get(overflow_id, opts = {})
      data, _status_code, _headers = get_overflow_using_get_with_http_info(overflow_id, opts)
      data
    end

    # Retrieve a Overflow object
    # Retrieve the information for a Overflow.
    # @param overflow_id UUID overflow_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(Overflow, Fixnum, Hash)>] Overflow data, response status code and response headers
    def get_overflow_using_get_with_http_info(overflow_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OverflowApi.get_overflow_using_get ...'
      end
      # verify the required parameter 'overflow_id' is set
      if @api_client.config.client_side_validation && overflow_id.nil?
        fail ArgumentError, "Missing the required parameter 'overflow_id' when calling OverflowApi.get_overflow_using_get"
      end
      # resource path
      local_var_path = '/nucleus/v1/overflow/{overflow_id}'.sub('{' + 'overflow_id' + '}', overflow_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Overflow')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OverflowApi#get_overflow_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update a overflow settings
    # Update the information for a overflow setting registered with your firm.
    # @param overflow_settings overflow_settings
    # @param overflow_settings_id UUID overflow_settings_id
    # @param [Hash] opts the optional parameters
    # @return [OverflowSettings]
    def update_overflow_settings_using_put(overflow_settings, overflow_settings_id, opts = {})
      data, _status_code, _headers = update_overflow_settings_using_put_with_http_info(overflow_settings, overflow_settings_id, opts)
      data
    end

    # Update a overflow settings
    # Update the information for a overflow setting registered with your firm.
    # @param overflow_settings overflow_settings
    # @param overflow_settings_id UUID overflow_settings_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(OverflowSettings, Fixnum, Hash)>] OverflowSettings data, response status code and response headers
    def update_overflow_settings_using_put_with_http_info(overflow_settings, overflow_settings_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OverflowApi.update_overflow_settings_using_put ...'
      end
      # verify the required parameter 'overflow_settings' is set
      if @api_client.config.client_side_validation && overflow_settings.nil?
        fail ArgumentError, "Missing the required parameter 'overflow_settings' when calling OverflowApi.update_overflow_settings_using_put"
      end
      # verify the required parameter 'overflow_settings_id' is set
      if @api_client.config.client_side_validation && overflow_settings_id.nil?
        fail ArgumentError, "Missing the required parameter 'overflow_settings_id' when calling OverflowApi.update_overflow_settings_using_put"
      end
      # resource path
      local_var_path = '/nucleus/v1/overflow_setting/{overflow_settings_id}'.sub('{' + 'overflow_settings_id' + '}', overflow_settings_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(overflow_settings)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'OverflowSettings')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OverflowApi#update_overflow_settings_using_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
