=begin
#Hydrogen Nucleus API

#The Hydrogen Nucleus API

OpenAPI spec version: 1.9.4
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.20

=end

require 'date'

module NucleusApi
  class TransactionCode
    # category
    attr_accessor :category

    attr_accessor :create_date

    attr_accessor :id

    attr_accessor :is_buy

    attr_accessor :is_deposit

    attr_accessor :is_fee

    attr_accessor :is_transfer

    attr_accessor :metadata

    attr_accessor :secondary_id

    # subcategory
    attr_accessor :subcategory

    # transactionCode
    attr_accessor :transaction_code

    # transactionCodeDescription
    attr_accessor :transaction_code_description

    # transactionType
    attr_accessor :transaction_type

    attr_accessor :update_date

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'category' => :'category',
        :'create_date' => :'create_date',
        :'id' => :'id',
        :'is_buy' => :'is_buy',
        :'is_deposit' => :'is_deposit',
        :'is_fee' => :'is_fee',
        :'is_transfer' => :'is_transfer',
        :'metadata' => :'metadata',
        :'secondary_id' => :'secondary_id',
        :'subcategory' => :'subcategory',
        :'transaction_code' => :'transaction_code',
        :'transaction_code_description' => :'transaction_code_description',
        :'transaction_type' => :'transaction_type',
        :'update_date' => :'update_date'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'category' => :'String',
        :'create_date' => :'DateTime',
        :'id' => :'String',
        :'is_buy' => :'BOOLEAN',
        :'is_deposit' => :'BOOLEAN',
        :'is_fee' => :'BOOLEAN',
        :'is_transfer' => :'BOOLEAN',
        :'metadata' => :'Hash<String, String>',
        :'secondary_id' => :'String',
        :'subcategory' => :'String',
        :'transaction_code' => :'String',
        :'transaction_code_description' => :'String',
        :'transaction_type' => :'String',
        :'update_date' => :'DateTime'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'category')
        self.category = attributes[:'category']
      end

      if attributes.has_key?(:'create_date')
        self.create_date = attributes[:'create_date']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'is_buy')
        self.is_buy = attributes[:'is_buy']
      end

      if attributes.has_key?(:'is_deposit')
        self.is_deposit = attributes[:'is_deposit']
      end

      if attributes.has_key?(:'is_fee')
        self.is_fee = attributes[:'is_fee']
      end

      if attributes.has_key?(:'is_transfer')
        self.is_transfer = attributes[:'is_transfer']
      end

      if attributes.has_key?(:'metadata')
        if (value = attributes[:'metadata']).is_a?(Hash)
          self.metadata = value
        end
      end

      if attributes.has_key?(:'secondary_id')
        self.secondary_id = attributes[:'secondary_id']
      end

      if attributes.has_key?(:'subcategory')
        self.subcategory = attributes[:'subcategory']
      end

      if attributes.has_key?(:'transaction_code')
        self.transaction_code = attributes[:'transaction_code']
      end

      if attributes.has_key?(:'transaction_code_description')
        self.transaction_code_description = attributes[:'transaction_code_description']
      end

      if attributes.has_key?(:'transaction_type')
        self.transaction_type = attributes[:'transaction_type']
      end

      if attributes.has_key?(:'update_date')
        self.update_date = attributes[:'update_date']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @transaction_code.nil?
        invalid_properties.push('invalid value for "transaction_code", transaction_code cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @transaction_code.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          category == o.category &&
          create_date == o.create_date &&
          id == o.id &&
          is_buy == o.is_buy &&
          is_deposit == o.is_deposit &&
          is_fee == o.is_fee &&
          is_transfer == o.is_transfer &&
          metadata == o.metadata &&
          secondary_id == o.secondary_id &&
          subcategory == o.subcategory &&
          transaction_code == o.transaction_code &&
          transaction_code_description == o.transaction_code_description &&
          transaction_type == o.transaction_type &&
          update_date == o.update_date
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [category, create_date, id, is_buy, is_deposit, is_fee, is_transfer, metadata, secondary_id, subcategory, transaction_code, transaction_code_description, transaction_type, update_date].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NucleusApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
